#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"


#define	Number	pow(10,3)	//the numebr of data
dsfmt_t dsfmt1;				//random number

double rand_exp( double mu){	//rand : exp
	double x = dsfmt_genrand_close_open(&dsfmt1) ;
	double y = -mu * log(x) ;
	return y;
}

int double_comp(const void *_a, const void *_b) {	//for qsort
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return -1;
	else if (a < b)	return 1;
	else			return 0;
}


int main(void){
	
	//Seed of random number
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	int i, j;
	double Fe,F;
	double z ,x;
	double *rand;
	rand = (double *)calloc( Number , sizeof(double) );
	
	FILE *fp;
	if( (fp = fopen("problem3_6_2.dat","w")) == NULL){
		printf("FILE Error\n");
		exit(1);
	}
	
	double mu = 2.0;		//the average of rand
	for( i= 0; i< Number ; i++){	//generate the random number
		rand[i] = rand_exp(mu);
	}
	//F
	qsort( rand , Number , sizeof(double) , double_comp);
	for(i = 0; i < Number ; i++){
		Fe = rand[i]/Number;
		F = exp(-rand[i]/mu);
		z = (i==0 || fabs(Fe-F) > z)? fabs(Fe-F) : z;
	}
	x = z * sqrt(Number);
	
	if( x >= 1.36){
		fprintf(fp , "significant :xi=%f\n" , x);
	}
	else{
		fprintf( fp ,"not significant : %f\n" , x);
	}
	
	
	fclose(fp);
	free(rand);
	
	return 0;
}
