#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"


#define	Number	pow(10,3)	//the number of data
dsfmt_t dsfmt1;				//random number

double rand_gauss( double mu , double sigma ){	//rand : gauss
	double x1 = dsfmt_genrand_close_open(&dsfmt1);
	double x2 = dsfmt_genrand_close_open(&dsfmt1);
	double y  = sigma * ( sqrt(-2 * log(x1) ) * cos( 2*M_PI * x2)) + mu;
	return y;
}

int double_comp(const void *_a, const void *_b) {	//for qsort
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return -1;
	else if (a < b)	return 1;
	else			return 0;
}


int main(void){
	
	//Seed of random numebr
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	int i, j;
	double Fe,F;
	double z,x;
	double *rand;
	rand = (double *)calloc( Number , sizeof(double) );

	
	FILE *fp;
	if( (fp = fopen("problem3_6_2.dat","w")) == NULL){
		printf("FILE Error\n");
		exit(1);
	}
	
	double mu = 1.0;		//the average of rand
	double sigma = 1.0;		//the std deviation of rand
	
	for( i= 0; i< Number ; i++){	//generate the random number
		rand[i] = rand_gauss(mu ,sigma);
	}
	
	//
	//F
	qsort( rand , Number , sizeof(double) , double_comp);
	for(i = 0; i < Number ; i++){
		Fe = rand[i]/Number;
		F = exp(- pow(x-mu,2)/(2.0*pow(sigma,2)))/(sqrt(2*M_PI)*sigma);
		z = (i==0 || fabs(Fe-F) > z)? fabs(Fe-F) : z;
	}
	x = z * sqrt(Number);
	
	if( x >= 1.36){
		fprintf(fp , "significant :%f\n" , x);
	}
	else{
		fprintf( fp ,"not significant : %f\n" , x);
	}
	
	fclose(fp);
	free(rand);
	
	return 0;
}



